(**************************************************************************

     $RCSfile: MathIEEEDoubTrans.mod $
  Description: Interface to mathieeedoubtrans.library

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] MathIEEEDoubTrans;

(*
  This module is not defined.  This is because the compiler cannot yet
  handle the LONGREAL as an 8-byte IEEE double-precision real.
  Have patience.
*)

(*
IMPORT SYS := SYSTEM, Kernel, e := Exec, m := MathLibrary;


(*-- MathIEEEDoubTrans Base variable --------------------------------------*)

CONST

  mathIEEEDoubTransName * = "mathieeedoubtrans.library";

VAR

  base * : MathIEEEBasePtr;


(*-- Library Functions ------------------------------------------------*)

PROCEDURE Atan* [base,-30]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Sin* [base,-36]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Cos* [base,-42]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Tan* [base,-48]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Sincos* [base,-54]
  ( VAR cos[8] : e.DOUBLE;
    parm [0]   : e.DOUBLE )
   : e.DOUBLE;

PROCEDURE Sinh* [base,-60]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Cosh* [base,-66]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Tanh* [base,-72]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Exp* [base,-78]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Log* [base,-84]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Pow* [base,-90]
  ( exp  [1] : e.DOUBLE;
    parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Sqrt* [base,-96]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Tieee* [base,-102]
  ( parm [0] : e.DOUBLE )
  : e.SINGLE;

PROCEDURE Fieee* [base,-108]
  ( parm [0] : e.SINGLE )
  : e.DOUBLE;

PROCEDURE Asin* [base,-114]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Acos* [base,-120]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

PROCEDURE Log10* [base,-126]
  ( parm [0] : e.DOUBLE )
  : e.DOUBLE;

(*-- Library Base variable --------------------------------------------*)

<*$LongVars-*>

(*-----------------------------------*)
PROCEDURE* [0] CloseLib (VAR rc : LONGINT);

BEGIN (* CloseLib *)
  IF base # NIL THEN e.CloseLibrary (base) END
END CloseLib;

BEGIN
  base :=
    SYS.VAL ( MathIEEEBasePtr, e.OpenLibrary (Name, e.libraryMinimum) );
  IF base = NIL THEN HALT (100) END;
  Kernel.SetCleanup (CloseLib)
*)
END MathIEEEDoubTrans.
