(**************************************************************************

     $RCSfile: MathResource.mod $
  Description: Interface to MathIEEE.resource

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  $VER: mathresource.h 1.2 (13.7.90)
  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] MathResource;

IMPORT e := Exec, s := Sets;


(*
**
**      Data structure returned by OpenResource of:
**      "MathIEEE.resource"
**
*)


(*
*       The 'Init' entries are only used if the corresponding
*       bit is set in the Flags field.
*
*       So if you are just a 68881, you do not need the Init stuff
*       just make sure you have cleared the Flags field.
*
*       This should allow us to add Extended Precision later.
*
*       For Init users, if you need to be called whenever a task
*       opens this library for use, you need to change the appropriate
*       entries in MathIEEELibrary.
*)

TYPE

  MathIEEEResourcePtr * = POINTER TO MathIEEEResource;
  MathIEEEResource * = RECORD (e.NodeBase)
    node *         : e.Node;
    flags *        : s.SET16;
    baseAddr *     : e.APTR; (* ptr to 881 if exists *)
    dblBasInit *   : e.PROC;
    dblTransInit * : e.PROC;
    sglBasInit *   : e.PROC;
    sglTransInit * : e.PROC;
    extBasInit *   : e.PROC;
    extTransInit * : e.PROC;
  END; (* MathIEEEResource *)

CONST

(* definations for MathIEEEResourceFLAGS *)
  dblBas        * = 0;
  dblTrans      * = 1;
  sglBas        * = 2;
  sglTrans      * = 3;
  extBas        * = 4;
  extTrans      * = 5;

END MathResource.
