(**************************************************************************

     $RCSfile: Misc.mod $
  Description: Interface to misc.resource

   Created by: fjc (Frank Copeland)
    $Revision: 3.8 $
      $Author: fjc $
        $Date: 1995/06/04 23:13:14 $

  Includes Release 40.15

  (C) Copyright 1985-1993 Commodore-Amiga, Inc.
      All Rights Reserved

  Oberon-A interface Copyright  1994-1995, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

***************************************************************************)

<* STANDARD- *>

MODULE [2] Misc;

IMPORT e := Exec;


(*
**      $VER: misc.h 36.13 (6.5.90)
**
**      Unit number definitions for "misc.resource"
*)

CONST

(*
 * Unit number definitions.  Ownership of a resource grants low-level
 * bit access to the hardware registers.  You are still obligated to follow
 * the rules for shared access of the interrupt system (see
 * exec.library/SetIntVector or cia.resource as appropriate).
 *)
  serialPort   * = 0; (* Amiga custom chip serial port registers
                         (SERDAT,SERDATR,SERPER,ADKCON, and interrupts) *)
  serialBits   * = 1; (* Serial control bits (DTR,CTS, etc.) *)
  parallelPort * = 2; (* The 8 bit parallel data port
                         (CIAAPRA & CIAADDRA only!) *)
  parallelBits * = 3; (* All other parallel bits & interrupts
                         (BUSY,ACK,etc.) *)

  miscName * = "misc.resource";


(*-- Resource Base variable --------------------------------------------*)

VAR

  base * : e.APTR;


(*-- Resource Functions ------------------------------------------------*)

(*
**      $VER: misc_protos.h 36.2 (7.11.90)
*)

PROCEDURE AllocMiscResource* [base,-6]
  ( unitNum [0] : e.ULONG;
    name    [9] : ARRAY OF CHAR )
  : e.APTR;
PROCEDURE FreeMiscResource* [base,-12]
  ( unitNum [0] : e.ULONG );

BEGIN base := NIL
END Misc.
