(*************************************************************************

     $RCSfile: OberonLib.mod $
  Description: Partial clone of AmigaOberon's OberonLib module.

   Created by: fjc (Frank Copeland)
    $Revision: 1.3 $
      $Author: fjc $
        $Date: 1995/06/04 23:22:41 $

  Copyright  1994, Frank Copeland.
  This file is part of the Oberon-A Library.
  See Oberon-A.doc for conditions of use and distribution.

*************************************************************************)

<* STANDARD- *>

(* $CLEAR OberonA *)
(* $IF OberonA <* IF OberonA THEN *> *)
MODULE OberonLib;
(* $ELSE <* ELSE *> *)
MODULE OAOberonLib;
(* $END <* ELSE *> *)

IMPORT SYS := SYSTEM, Kernel, s := Sets;

TYPE
  APTR = SYS.ADDRESS;
  MessagePtr = APTR;

VAR
  wbStarted -: BOOLEAN;
  dosCmdLen -: LONGINT;
  dosCmdBuf -: APTR;
  wbenchMsg *: MessagePtr;
  MemReqs   *: s.SET32;

CONST
  memClear = 16;


PROCEDURE New* ( VAR adr : APTR; size : LONGINT );
BEGIN (* New *)
  Kernel.Allocate (adr, size, MemReqs)
END New;


PROCEDURE Dispose* ( VAR adr : APTR );
BEGIN (* Dispose *)
  Kernel.Dispose (adr)
END Dispose;


PROCEDURE SetA5*;
BEGIN (* SetA5 *)
END SetA5;


BEGIN
  wbStarted := Kernel.fromWorkbench;
  dosCmdBuf := Kernel.dosCmdBuf;
  dosCmdLen := Kernel.dosCmdLen;
  wbenchMsg := Kernel.WBenchMsg;
  MemReqs := {memClear}

(* $IF OberonA <* IF OberonA THEN *> *)
END OberonLib.
(* $ELSE <* ELSE *> *)
END OAOberonLib.
(* $END <* ELSE *> *)
