(*************************************************************************

     $RCSfile: RexxUtil.mod $
  Description: Rexx Variable Interface
     Requires: The object file rexxvars.o must be explicitly linked with
               the program.

   Created by: fjc (Frank Copeland)
    $Revision: 3.7 $
      $Author: fjc $
        $Date: 1995/06/29 19:06:56 $

  Copyright  1994, Frank Copeland.
  This file is part of the Oberon-A Interface.
  See Oberon-A.doc for conditions of use and distribution.

*************************************************************************)

<* STANDARD- *>

MODULE [4] RexxUtil ["rexxvars.o"];

IMPORT SYS := SYSTEM, e := Exec, rx := Rexx;

(*------------------------------------*)
PROCEDURE CheckRexxMsg * ["CheckRexxMsg"]
  ( rexxmsg [8] : rx.RexxMsgPtr )
  : BOOLEAN;


(*------------------------------------*)
PROCEDURE [0] GetRexxVar *
  ( rexxmsg    : rx.RexxMsgPtr;
    name       : ARRAY OF CHAR;
    VAR result : e.STRPTR )
  : LONGINT;

  (*------------------------------------*)
  (* Secondary result is returned in register A1 *)
  PROCEDURE GetRexxVar0 ["GetRexxVar"]
    ( rexxmsg    [8] : rx.RexxMsgPtr;
      name       [9] : ARRAY OF CHAR )
    : LONGINT;

<*$ReturnChk-*>
<*$CopyArrays-*>
BEGIN
  SYS.PUTREG (0, GetRexxVar0 (rexxmsg, name));
  SYS.GETREG (9, result)
END GetRexxVar;

(*------------------------------------*)
PROCEDURE SetRexxVar * ["SetRexxVar"]
  ( rexxmsg [8] : rx.RexxMsgPtr;
    name    [9] : ARRAY OF CHAR;
    value   [0] : ARRAY OF CHAR;
    length  [1] : LONGINT )
  : LONGINT;

END RexxUtil.
